<project name="Build specific targets and properties" default="noDefault" basedir=".">

	<!-- ===================================================================== -->
	<!-- Run a given ${target} on all elements being built -->
	<!-- ===================================================================== -->
	<target name="allElements">
        <ant antfile="${genericTargets}" target="${target}">
            <property name="type" value="feature" />
            <property name="id" value="org.eclipse.mtj" />
        </ant>
        <ant antfile="${genericTargets}" target="${target}">
            <property name="type" value="feature" />
            <property name="id" value="org.eclipse.mtj.examples" />
        </ant>
        <ant antfile="${genericTargets}" target="${target}">
            <property name="type" value="feature" />
            <property name="id" value="org.eclipse.mtj.sdk" />
        </ant>
        <ant antfile="${genericTargets}" target="${target}">
            <property name="type" value="feature" />
            <property name="id" value="org.eclipse.mtj.pulsar" />
        </ant>
	</target>

	<!-- ===================================================================== -->
	<!-- Targets to assemble the built elements for particular configurations  -->
	<!-- These generally call the generated assemble scripts (named in -->
	<!-- ${assembleScriptName}) but may also add pre and post processing -->
	<!-- Add one target for each root element and each configuration -->
	<!-- ===================================================================== -->

	<target name="assemble.org.eclipse.mtj">
        <property name="archiveName" value="dsdp-mtj-runtime-${buildId}.zip"/>
		<ant antfile="${assembleScriptName}" />
        <antcall target="signMTJ" />
        <antcall target="unpackUpdateJarsForPackaging" />
	</target>
    <target name="assemble.org.eclipse.mtj.examples">
        <property name="archiveName" value="dsdp-mtj-examples-${buildId}.zip"/>
        <ant antfile="${assembleScriptName}" />
        <antcall target="signMTJ" />    	
        <antcall target="unpackUpdateJarsForPackaging" />
    </target>
    <target name="assemble.org.eclipse.mtj.sdk">
        <property name="archiveName" value="dsdp-mtj-SDK-${buildId}.zip"/>
        <ant antfile="${assembleScriptName}" />
    	<antcall target="signMTJ" />
        <antcall target="unpackUpdateJarsForPackaging" />
    </target>

    <target name="assemble.org.eclipse.mtj.pulsar">
        <property name="archiveName" value="dsdp-mtj-Pulsar-${buildId}.zip"/>
        <ant antfile="${assembleScriptName}" />
        <antcall target="signMTJ" />
        <antcall target="unpackUpdateJarsForPackaging" />
    </target>
        	
    <target name="unpackUpdateJarsForPackaging">
        <property name="tmpsite" value="${buildDirectory}/tmpsite"/>
        <exec executable="unzip" dir="${buildDirectory}/${buildLabel}">
            <arg line="-q ${archiveName} -d ${tmpsite}" />
        </exec>
    	
    	<!--copy orbit plugins-->
        <copy todir="${tmpsite}/eclipse/plugins">
            <fileset dir="${buildDirectory}/plugins">
                <include name="org.objectweb*.jar"/>
            	<include name="org.antlr.runtime*.jar"/>
            	<include name="org.mortbay.jett*.jar"/>
            </fileset>
        </copy>
    	
        <copy todir="${tmpUpdateSiteDirectory}" verbose="true">
            <fileset dir="${tmpsite}/eclipse"/>
        </copy>

        <!--unpackUpdateJars site="${tmpsite}/eclipse" output="${tmpsite}/new/eclipse"/-->
    	
    	<antcall target="generate.metadata">
    		<param name="source_mtj" value="${tmpsite}/eclipse"/>
    		<param name="output_mtj" value="${tmpsite}/new"/>
    	</antcall>
    	
        <antcall target="packageLicenseFiles"/>
    	
        <zip destfile="${buildDirectory}/${buildLabel}/${archiveName}"
            basedir="${tmpsite}/new"
        />
        <delete dir="${tmpsite}"/>
    </target>
	
    <target name="packageLicenseFiles">
        <copy file="${rootScriptsDirectory}/templateFiles/epl-v10.html" todir="${tmpsite}/new" verbose="true"/>
        <copy file="${rootScriptsDirectory}/templateFiles/notice.html" todir="${tmpsite}/new" verbose="true"/>
    </target>
	
	<!-- ===================================================================== -->
	<!-- Check out map files from correct repository -->
	<!-- Replace values for cvsRoot, package and mapVersionTag as desired. -->
	<!-- ===================================================================== -->
	<target name="checkLocal">
		<available property="mapsLocal" file="${buildDirectory}/maps" />
	</target>

	<target name="getMapFiles" depends="checkLocal" unless="mapsLocal">
		<echo message="Copy Map Files" />
		<copy todir="${buildDirectory}/maps" overwrite="true">
			<fileset dir="${mapsDirectory}" />
		</copy>
	</target>

	<target name="tagMapFiles" if="tagMaps">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do before setup -->
	<!-- ===================================================================== -->
	<target name="preSetup">
		<mkdir dir="${buildDirectory}/${buildLabel}" />
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after setup but before starting the build proper -->
	<!-- ===================================================================== -->
	<target name="postSetup">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do before fetching the build elements -->
	<!-- ===================================================================== -->
	<target name="preFetch">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after the fetch -->
	<!-- ===================================================================== -->
	<target name="postFetch">
		<replace dir="${buildDirectory}/plugins" value="${timestamp}" token="@buildid@">
			<include name="**/about.mappings" />
		</replace>	
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do before generating build scripts -->
	<!-- ===================================================================== -->
	<target name="preGenerate">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after generating the build scripts -->
	<!-- ===================================================================== -->
	<target name="postGenerate">
		<antcall target="clean" />
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do before assembling -->
	<!-- ===================================================================== -->
	<target name="preAssemble">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after assembling-->
	<!-- ===================================================================== -->
	<target name="postAssemble">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do before running the build.xmls for the elements being built. -->
	<!-- ===================================================================== -->
	<target name="preProcess">
		<replace dir="${buildDirectory}/plugins" value="${timestamp}" token="@build@">
			<include name="**/about.mappings" />
		</replace>
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after running the build.xmls for the elements being built. -->
	<!-- ===================================================================== -->
	<target name="postProcess">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after everything is built and assembled -->
	<!-- (e.g., testing, posting, emailing, ...) -->
	<!-- ===================================================================== -->
	<target name="postBuild">
		<antcall target="gatherLogs" />
	</target>

	<!-- ===================================================================== -->
	<!-- Helper targets -->
	<!-- ===================================================================== -->
	<target name="gatherLogs">
		<mkdir dir="${buildDirectory}/${buildLabel}/compilelogs" />
		<antcall target="allElements">
			<param name="target" value="gatherLogs" />
		</antcall>

		<unzip dest="${buildDirectory}/${buildLabel}/compilelogs" overwrite="true">
			<fileset dir="${buildDirectory}/features/org.eclipse.mtj.sdk">
				<include name="*.log.zip" />
			</fileset>
		</unzip>
	</target>
	<target name="clean" unless="noclean">
		<antcall target="allElements">
			<param name="target" value="cleanElement" />
		</antcall>
	</target>

    <!-- ===================================================================== -->
    <!-- Sign target                                                        -->
    <!-- ===================================================================== -->
    <target name="signMTJ" if="sign">
        <echo message="Sign MTJ Features and Plugins" />
        <property name="packtmp" value="${buildDirectory}/packtmp" />
        <property name="stagingDirectoryOutput" value="/home/data/httpd/download-staging.priv/dsdp/mtj/${buildId}-out" />
        <property name="stagingDirectory" value="/home/data/httpd/download-staging.priv/dsdp/mtj" />
        <property name="outputFile" value="${stagingDirectoryOutput}/${archiveName}" />
        <mkdir dir="${packtmp}" />
        <move file="${buildDirectory}/${buildLabel}/${archiveName}" tofile="${packtmp}/${archiveName}" />   
        
        <!--push drop to staging directory-->
        <echo message="push drop to staging directory" />
    	<copy file="${packtmp}/${archiveName}" todir="${stagingDirectory}" verbose="true"/>
    	<chmod file="${stagingDirectory}/${archiveName}" perm="ugo+rw"/>

        <!--invoke sign script and wait-->
        <echo message="invoke sign script and wait" />
        <exec dir="." executable="ssh" output="signing.txt" append="true">
            <arg line="build.eclipse.org &quot;cd ${stagingDirectory}; /usr/bin/sign ${stagingDirectory}/${archiveName} mail ${stagingDirectoryOutput}&quot;" />
        </exec>

        <!--Wait for build to be available -->
        <antcall target="waitForChangedAttribs">
            <param name="signed.file" value="${stagingDirectoryOutput}/${archiveName}" />
        </antcall>

        <!--copy zip back to build machine -->
        <sleep minutes="2" />
        <echo message="copy zip back to build machine" />
        <copy file="${stagingDirectory}/${buildId}-out/${archiveName}" todir="${buildDirectory}/${buildLabel}" verbose="true"/>

        <!--delete files on build.eclipse.org-->
        <echo message="delete temp files on build.eclipse.org" />
    	<delete dir="${stagingDirectory}/${buildId}-out" verbose="true"/>
    	<delete file="${stagingDirectory}/${archiveName}" verbose="true"/>
    	
    </target>

    <target name="waitForChangedAttribs" unless="attribs.changed">
        <antcall target="compareAttribs" inheritAll="false"/>
    </target>

    <target name="compareAttribs">
        <available property="attribs.changed" file="${signed.file}"/>
        <sleep seconds="120" />
        <antcall target="waitForChangedAttribs" />
    </target>

    <target name="generate.metadata">
        <echo message="Generate Metadata" />
        <java jar="${eclipse.home}/plugins/org.eclipse.equinox.launcher.jar"
              fork="true"
              timeout="10800000"
              jvm="${jvm15.home}/bin/java"
              failonerror="true"
              maxmemory="768m"
              error="${buildDirectory}/errorlog.txt"
              dir="${buildDirectory}"
              output="${buildDirectory}/p2metadata_mtj.txt">
            <arg line="-application org.eclipse.equinox.p2.publisher.FeaturesAndBundlesPublisher" />
            <arg line="-metadataRepository file:${output_mtj}" />
            <arg line="-artifactRepository file:${output_mtj}" />
        	<arg line="-source ${source_mtj}" />        	
            <arg line="-compress" />
        	<arg line="-publishArtifacts" />
            <arg line="-vmargs -Xmx256M" />
        </java>
    </target>
	
	<!-- ===================================================================== -->
	<!-- Default target                                                        -->
	<!-- ===================================================================== -->
	<target name="noDefault">
		<echo message="You must specify a target when invoking this file" />
	</target>

</project>
